> ## Documentation Index
> Fetch the complete documentation index at: https://docs.whop.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create company token transaction

> Create a token transaction to add, subtract, or transfer tokens for a member within a company.

Required permissions:
 - `company_token_transaction:create`
 - `member:basic:read`
 - `company:basic:read`



## OpenAPI

````yaml /openapi/api-v1-stable.json post /company_token_transactions
openapi: 3.1.0
info:
  description: >-
    The Whop REST API. Please see
    https://docs.whop.com/developer/api/getting-started for more details.
  termsOfService: https://whop.com/tos-developer-api/
  title: Whop API
  version: 1.0.0
  x-api-version-date: 2026-08-21-1
servers:
  - description: Production Whop API
    url: https://api.whop.com/api/v1
  - description: Sandbox Whop API
    url: https://sandbox-api.whop.com/api/v1
security: []
tags:
  - description: Products
    name: Products
  - description: Payments
    name: Payments
  - description: Refunds
    name: Refunds
  - description: Disputes
    name: Disputes
  - description: Dispute alerts
    name: Dispute alerts
  - description: Resolution center cases
    name: Resolution center cases
  - description: Checkout configurations
    name: Checkout configurations
  - description: Setup intents
    name: Setup intents
  - description: Payment methods
    name: Payment methods
  - description: Invoices
    name: Invoices
  - description: Promo codes
    name: Promo codes
  - description: Card transactions
    name: Card transactions
  - description: Ledger accounts
    name: Ledger accounts
  - description: Withdrawals
    name: Withdrawals
  - description: Payout methods
    name: Payout methods
  - description: Verifications
    name: Verifications
  - description: Identity profiles
    name: Identity profiles
  - description: Payout accounts
    name: Payout accounts
  - description: Topups
    name: Topups
  - description: Companies
    name: Companies
  - description: Authorized users
    name: Authorized users
  - description: Fee markups
    name: Fee markups
  - description: Members
    name: Members
  - description: Memberships
    name: Memberships
  - description: Leads
    name: Leads
  - description: Entries
    name: Entries
  - description: Shipments
    name: Shipments
  - description: Reviews
    name: Reviews
  - description: Company token transactions
    name: Company token transactions
  - description: Affiliates
    name: Affiliates
  - description: Experiences
    name: Experiences
  - description: Forums
    name: Forums
  - description: Forum posts
    name: Forum posts
  - description: Chat channels
    name: Chat channels
  - description: Support channels
    name: Support channels
  - description: Messages
    name: Messages
  - description: Reactions
    name: Reactions
  - description: Dm members
    name: Dm members
  - description: Dm channels
    name: Dm channels
  - description: Notifications
    name: Notifications
  - description: Courses
    name: Courses
  - description: Course chapters
    name: Course chapters
  - description: Course lessons
    name: Course lessons
  - description: Course students
    name: Course students
  - description: Course lesson interactions
    name: Course lesson interactions
  - description: Apps
    name: Apps
  - description: Webhooks
    name: Webhooks
  - description: App builds
    name: App builds
  - description: Access tokens
    name: Access tokens
  - description: Account links
    name: Account links
  - description: Files
    name: Files
  - description: Ai chats
    name: Ai chats
  - description: Bounties
    name: Bounties
  - description: Stats
    name: Stats
  - description: Conversions
    name: Conversions
  - description: Ad reports
    name: Ad reports
paths:
  /company_token_transactions:
    post:
      tags:
        - Company token transactions
      summary: Create company token transaction
      description: >-
        Create a token transaction to add, subtract, or transfer tokens for a
        member within a company.


        Required permissions:
         - `company_token_transaction:create`
         - `member:basic:read`
         - `company:basic:read`
      operationId: createCompanyTokenTransaction
      parameters: []
      requestBody:
        content:
          application/json:
            schema:
              description: Parameters for CreateCompanyTokenTransaction
              oneOf:
                - description: Autogenerated input type of CreateCompanyTokenTransaction
                  properties:
                    amount:
                      description: >-
                        The positive number of tokens to transact. For example,
                        100.0 for 100 tokens.
                      example: 6.9
                      type: number
                    company_id:
                      description: >-
                        The unique identifier of the company to create the
                        transaction in, starting with 'biz_'.
                      example: biz_xxxxxxxxxxxxxx
                      type: string
                    description:
                      description: >-
                        A human-readable description of why the transaction was
                        created.
                      type:
                        - string
                        - 'null'
                    destination_user_id:
                      description: >-
                        The unique identifier of the user receiving the tokens.
                        Required when the transaction type is 'transfer'.
                      type: string
                    idempotency_key:
                      description: >-
                        A unique key to prevent duplicate transactions. Use a
                        UUID or similar unique string.
                      type:
                        - string
                        - 'null'
                    transaction_type:
                      const: transfer
                      type: string
                    user_id:
                      description: >-
                        The unique identifier of the user whose token balance
                        will be affected, starting with 'user_'.
                      example: user_xxxxxxxxxxxxx
                      type: string
                  required:
                    - amount
                    - company_id
                    - transaction_type
                    - user_id
                    - destination_user_id
                  title: CreateCompanyTokenTransactionInputTransactionTypeTransfer
                  type: object
                - description: Autogenerated input type of CreateCompanyTokenTransaction
                  properties:
                    amount:
                      description: >-
                        The positive number of tokens to transact. For example,
                        100.0 for 100 tokens.
                      example: 6.9
                      type: number
                    company_id:
                      description: >-
                        The unique identifier of the company to create the
                        transaction in, starting with 'biz_'.
                      example: biz_xxxxxxxxxxxxxx
                      type: string
                    description:
                      description: >-
                        A human-readable description of why the transaction was
                        created.
                      type:
                        - string
                        - 'null'
                    idempotency_key:
                      description: >-
                        A unique key to prevent duplicate transactions. Use a
                        UUID or similar unique string.
                      type:
                        - string
                        - 'null'
                    transaction_type:
                      const: add
                      type: string
                    user_id:
                      description: >-
                        The unique identifier of the user whose token balance
                        will be affected, starting with 'user_'.
                      example: user_xxxxxxxxxxxxx
                      type: string
                  required:
                    - amount
                    - company_id
                    - transaction_type
                    - user_id
                  title: CreateCompanyTokenTransactionInputTransactionTypeAdd
                  type: object
                - description: Autogenerated input type of CreateCompanyTokenTransaction
                  properties:
                    amount:
                      description: >-
                        The positive number of tokens to transact. For example,
                        100.0 for 100 tokens.
                      example: 6.9
                      type: number
                    company_id:
                      description: >-
                        The unique identifier of the company to create the
                        transaction in, starting with 'biz_'.
                      example: biz_xxxxxxxxxxxxxx
                      type: string
                    description:
                      description: >-
                        A human-readable description of why the transaction was
                        created.
                      type:
                        - string
                        - 'null'
                    idempotency_key:
                      description: >-
                        A unique key to prevent duplicate transactions. Use a
                        UUID or similar unique string.
                      type:
                        - string
                        - 'null'
                    transaction_type:
                      const: subtract
                      type: string
                    user_id:
                      description: >-
                        The unique identifier of the user whose token balance
                        will be affected, starting with 'user_'.
                      example: user_xxxxxxxxxxxxx
                      type: string
                  required:
                    - amount
                    - company_id
                    - transaction_type
                    - user_id
                  title: CreateCompanyTokenTransactionInputTransactionTypeSubtract
                  type: object
              type: object
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CompanyTokenTransaction'
          description: A successful response
        '400':
          content:
            application/json:
              example:
                error:
                  code: parameter_missing
                  message: 'Missing required parameter: amount.'
                  param: amount
                  type: invalid_request_error
              schema:
                properties:
                  error:
                    properties:
                      code:
                        description: >-
                          A short string indicating the specific error code,
                          e.g. 'parameter_missing', 'parameter_invalid',
                          'invalid_json'
                        type:
                          - string
                          - 'null'
                      message:
                        type: string
                      param:
                        description: The parameter that caused the error, if applicable
                        type:
                          - string
                          - 'null'
                      type:
                        type: string
                    required:
                      - type
                      - message
                    type: object
                required:
                  - error
                type: object
          description: Bad request
        '401':
          content:
            application/json:
              example:
                error:
                  message: Invalid or missing API key
                  type: unauthorized
              schema:
                properties:
                  error:
                    properties:
                      code:
                        description: >-
                          A short string indicating the specific error code,
                          e.g. 'parameter_missing', 'parameter_invalid',
                          'invalid_json'
                        type:
                          - string
                          - 'null'
                      message:
                        type: string
                      param:
                        description: The parameter that caused the error, if applicable
                        type:
                          - string
                          - 'null'
                      type:
                        type: string
                    required:
                      - type
                      - message
                    type: object
                required:
                  - error
                type: object
          description: Unauthorized
        '403':
          content:
            application/json:
              example:
                error:
                  message: You do not have permission to access this resource
                  type: forbidden
              schema:
                properties:
                  error:
                    properties:
                      code:
                        description: >-
                          A short string indicating the specific error code,
                          e.g. 'parameter_missing', 'parameter_invalid',
                          'invalid_json'
                        type:
                          - string
                          - 'null'
                      message:
                        type: string
                      param:
                        description: The parameter that caused the error, if applicable
                        type:
                          - string
                          - 'null'
                      type:
                        type: string
                    required:
                      - type
                      - message
                    type: object
                required:
                  - error
                type: object
          description: Forbidden
        '404':
          content:
            application/json:
              example:
                error:
                  message: Resource not found
                  type: not_found
              schema:
                properties:
                  error:
                    properties:
                      code:
                        description: >-
                          A short string indicating the specific error code,
                          e.g. 'parameter_missing', 'parameter_invalid',
                          'invalid_json'
                        type:
                          - string
                          - 'null'
                      message:
                        type: string
                      param:
                        description: The parameter that caused the error, if applicable
                        type:
                          - string
                          - 'null'
                      type:
                        type: string
                    required:
                      - type
                      - message
                    type: object
                required:
                  - error
                type: object
          description: Not found
        '422':
          content:
            application/json:
              example:
                error: null
              schema:
                properties:
                  error:
                    properties:
                      code:
                        description: >-
                          A short string indicating the specific error code,
                          e.g. 'parameter_missing', 'parameter_invalid',
                          'invalid_json'
                        type:
                          - string
                          - 'null'
                      message:
                        type: string
                      param:
                        description: The parameter that caused the error, if applicable
                        type:
                          - string
                          - 'null'
                      type:
                        type: string
                    required:
                      - type
                      - message
                    type: object
                required:
                  - error
                type: object
          description: Verification required
        '429':
          content:
            application/json:
              example:
                error: null
              schema:
                properties:
                  error:
                    properties:
                      code:
                        description: >-
                          A short string indicating the specific error code,
                          e.g. 'parameter_missing', 'parameter_invalid',
                          'invalid_json'
                        type:
                          - string
                          - 'null'
                      message:
                        type: string
                      param:
                        description: The parameter that caused the error, if applicable
                        type:
                          - string
                          - 'null'
                      type:
                        type: string
                    required:
                      - type
                      - message
                    type: object
                required:
                  - error
                type: object
          description: Too many requests
        '500':
          content:
            application/json:
              example:
                error:
                  message: An unexpected error occurred
                  type: internal_server_error
              schema:
                properties:
                  error:
                    properties:
                      code:
                        description: >-
                          A short string indicating the specific error code,
                          e.g. 'parameter_missing', 'parameter_invalid',
                          'invalid_json'
                        type:
                          - string
                          - 'null'
                      message:
                        type: string
                      param:
                        description: The parameter that caused the error, if applicable
                        type:
                          - string
                          - 'null'
                      type:
                        type: string
                    required:
                      - type
                      - message
                    type: object
                required:
                  - error
                type: object
          description: Internal server error
      security:
        - bearerAuth:
            - company_token_transaction:create
            - member:basic:read
            - company:basic:read
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Whop from '@whop/sdk';


            const client = new Whop({
              apiKey: process.env['WHOP_API_KEY'], // This is the default and can be omitted
            });


            const companyTokenTransaction = await
            client.companyTokenTransactions.create({
              amount: 6.9,
              company_id: 'biz_xxxxxxxxxxxxxx',
              destination_user_id: 'destination_user_id',
              transaction_type: 'transfer',
              user_id: 'user_xxxxxxxxxxxxx',
            });


            console.log(companyTokenTransaction.id);
components:
  schemas:
    CompanyTokenTransaction:
      description: >-
        A token transaction records a credit or debit to a member's token
        balance within a company, including transfers between members.
      properties:
        amount:
          description: >-
            The token amount for this transaction. Always a positive value
            regardless of transaction type.
          example: 6.9
          type: number
        company:
          description: The company whose token balance this transaction affects.
          properties:
            id:
              description: The unique identifier for the company.
              example: biz_xxxxxxxxxxxxxx
              type: string
            route:
              description: The slug/route of the company on the Whop site.
              type: string
            title:
              description: The written name of the company.
              type: string
          required:
            - id
            - title
            - route
          type: object
        created_at:
          description: The datetime the company token transaction was created.
          example: '2023-12-01T05:00:00.401Z'
          format: date-time
          type: string
        description:
          description: >-
            Free-text description explaining the reason for this token
            transaction. Null if no description was provided.
          example: Reward for completing onboarding
          type:
            - string
            - 'null'
        id:
          description: The unique identifier for the company token transaction.
          type: string
        idempotency_key:
          description: >-
            A unique key used to prevent duplicate transactions when retrying
            API requests. Null if no idempotency key was provided.
          example: txn_reward_usr_123_2024
          type:
            - string
            - 'null'
        linked_transaction_id:
          description: >-
            The ID of the corresponding transaction on the other side of a
            transfer. Null if this is not a transfer transaction.
          type:
            - string
            - 'null'
        member:
          description: The member whose token balance was affected by this transaction.
          properties:
            id:
              description: The unique identifier for the company member.
              type: string
          required:
            - id
          type: object
        transaction_type:
          $ref: '#/components/schemas/CompanyTokenTransactionTypes'
          description: >-
            The direction of this token transaction (add, subtract, or
            transfer).
        user:
          description: The user whose token balance was affected by this transaction.
          properties:
            id:
              description: The unique identifier for the user.
              example: user_xxxxxxxxxxxxx
              type: string
            name:
              description: The user's display name shown on their public profile.
              example: John Doe
              type:
                - string
                - 'null'
            username:
              description: The user's unique username shown on their public profile.
              example: johndoe42
              type: string
          required:
            - id
            - name
            - username
          type: object
      required:
        - id
        - transaction_type
        - amount
        - description
        - created_at
        - linked_transaction_id
        - idempotency_key
        - user
        - member
        - company
      type: object
    CompanyTokenTransactionTypes:
      description: The type of token transaction
      enum:
        - add
        - subtract
        - transfer
      type: string
  securitySchemes:
    bearerAuth:
      bearerFormat: auth-scheme
      description: >-
        An Account API key, account-scoped JWT, App API key, or user OAuth
        token. Prepend the key or token with `Bearer`, for example `Bearer
        ***************************`.
      scheme: bearer
      type: http

````